// ************************************************************
//   This class is part of the Sizmek HTML5 Weather Ad Feature 
//   ALL RIGHTS RESERVED TO © 2017 Sizmek, Inc.
// ************************************************************
// ************************************************************

// Handle Display Build
function do_temp_display(_obj, _config, _options) {
    // Establish Weather Observation Object	
    var wthr_obj = _obj.response.ob;
    // Display Weather Object
    //console.log ( wthr_obj );
        
    // Establish reference to div container
	var container = document.getElementById(_config.container);
	// Set Container Div Width
    container.style.width = _options.width + 'px';
    // Set Container Div Height
    container.style.height = _options.height + 'px';

    // Determine if using Fahrenheit of Celcius
    var tempCF = _options.wthr_temp_cf;
    // Establish Temperature Threshold
    var threshold = _options.wthr_temp_threshold;
  	// Establish Reference to temperature
  	var temp;
    // Establish Actual Temperature in Appropriate Measurement
    if (tempCF === 'F') { temp = wthr_obj.tempF; } else if (tempCF === 'C') { temp = wthr_obj.tempC; }

    // Build Appropriate HTML for warm or cold weather
    if (temp >= threshold) {
        // Build Warm Weather Display
        do_weather_display(temp + '&deg;', 'Warm Weather Creative',  _config, container);
    } else {
        // Build Cold Weather Display
        do_weather_display(temp + '&deg;', 'Cold Weather Creative',  _config, container);
    }
}

// Handle Display Build
function do_cond_display(_obj, _config, _options) {
	// Establish Weather Observation Object	
    var wthr_obj = _obj.response.ob;
    // Display Weather Object
    //console.log(wthr_obj);
    
    // Establish reference to div container
	var container = document.getElementById(_config.container);
	// Set Container Div Width
    container.style.width = _options.width + 'px';
    // Set Container Div Height
    container.style.height = _options.height + 'px';
    // Set up String for Weather Code
    var str;
    // Determine if using Fahrenheit of Celcius
    var codes = _options.wthr_cond;
    // Grab Weather Code from response object
    var wthr_code = wthr_obj.weatherCoded;
    // Grab Weather Code from response object
    var wthr_prim = wthr_obj.weatherPrimary; 
    // Set up Array to hold Weather Codes
    var arr = wthr_code.split(",");

    // If Weather API returns 3 codes, show bad weather
    if (arr.length === 3) {
        // Set Var to track code
        var cnt = 0;
        // Set Weather Code String
        str = arr[0].substring(2, arr[0].length);
        // Loop through Config file weather codes and if match exists, load content
        for (var i = 0; i < codes.length; i++) {
            if (str === codes[i]) {
                do_weather_display(codes[i], 'Matched Bad Weather',  _config, container);
            } else {
                cnt++;
            }
        }
        // If no match is found, show default bad weather
        if (cnt === codes.length) {
            do_weather_display(wthr_prim, 'Default Bad Weather',  _config, container);
        }

    } else if (arr.length == 2) {
        // Set Weather Code String
        str = arr[1];
        // Check if weather is good or bad - CL stands for clear
        // For full list of codes - http://www.aerisweather.com/support/docs/api/reference/weather-codes/
        if (str.substring(2, 4) != "CL") {
            // Build Bad Weather Display
            do_weather_display(wthr_prim, 'Bad Weather Creative',  _config, container);
        } else {
            // Build Good Weather Display
            do_weather_display(wthr_prim, 'Good Weather Creative',  _config, container);
        }
    } else if (arr.length === 1) {
        // Set Weather Code String
        str = arr[0];
        // Check if weather is good or bad - CL stands for clear
        if (str.substring(2, 4) != "CL" && str.substring(2, 4) != "FW") {
            // Build Bad Weather Display
            do_weather_display(wthr_prim, 'Bad Weather Creative',  _config, container);
        } else {
            // Build Good Weather Display
            do_weather_display(wthr_prim, 'Good Weather Creative',  _config, container);
        }
    }
}

function displayWeatherError(_str, _config, _options) {
	// Establish reference to div container
    var container = document.getElementById(_config.container);
    // Set Container Div Width
    container.style.width = _options.width + 'px';
    // Set Container Div Height
    container.style.height = _options.height + 'px';
	// Build HTML String
	var htm = "<div id='weather_error' class='weather_text'>" + _str + "</div>";
    htm += "<div id='weather_back'></div>";
    // Append HTML to the Target Div
    container.innerHTML = htm;
    
    // Listen for Click
    container.onclick = function () {
        // Check if working locally, if not, call EB.Clickthrough Method 
        if (!EB._isLocalMode) { EB.clickthrough('Weather_Click', _config.wthr_clickthrough); } else { window.open(_config.wthr_clickthrough, '_blank'); }
    };
}

function do_weather_display(_arg1, _arg2, _config, _container) {
    // Build HTML String for Cold Weather
    var htm = "<div id=weather_icon></div>";
    htm += "<div id='weather_text_a' class='weather_text'>" + _arg1 + "</div>";
    htm += "<div id='weather_text_b' class='weather_text'>" + _arg2 + "</div>";

    // Append HTML to the Target Div
    _container.innerHTML = htm;
    
    // Listen for Click
    _container.onclick = function () {
        // Check if working locally, if not, call EB.Clickthrough Method 
        if (!EB._isLocalMode) { EB.clickthrough('Weather_Click', _config.wthr_clickthrough); } else { window.open(_config.wthr_clickthrough, '_blank'); }
    };

}