// ************************************************************
//   This class is part of the Sizmek HTML5 Weather Ad Feature
//   ALL RIGHTS RESERVED TO © 2017 Sizmek, Inc.
// ************************************************************
// ************************************************************

// Handle Display Build
function displayWeather(_obj, _config, _options)  {
    // Establish Weather Location
    var wthr_place = _obj.response.place;
    // Establish Weather Observation Object
    var wthr_obj = _obj.response.ob;
    // Display Weather Object
    //console.log(wthr_obj);
    // Establish reference to div container
    var container = document.getElementById(_config.container);
    // Set Container Div Width
    container.style.width = _options.width + 'px';
    // Set Container Div Height
    container.style.height = _options.height + 'px';
    // Convert Timestamp to date object
    var currTime = new Date(wthr_obj.timestamp * 1000);
    // Create Default AM PM var
    var amPm = " am";
    // Determine the hour
    var HH = currTime.getHours();
    // Convert from 24 to 12 hour and adjust AM PM if necessary
    if (HH > 12) { HH = HH - 12; amPm = " pm"; }
    // Determine the minutes
    var MM = currTime.getMinutes();

    // Build HTML String
    var htm = "<div id=weather_icon></div>";
    htm += "<div id='weather_location' class='weather_text'>" + do_cap(wthr_place.name) + "</div>";
    htm += "<div class='weather_temp weather_text'><div id='weather_num'>" + wthr_obj.tempF + "</div><div id='weather_degree'>&deg;</div></div>";
    htm += "<div id='weather_display'><div id='weather_time' class='weather_text'>" + HH + ":" + MM + amPm + "</div>";
    htm += "<div id='weather_feels_like' class='weather_text'>Feels like: " + wthr_obj.feelslikeF + "</div></div>";

    // Append HTML to the Target Div
    container.innerHTML = htm;

    // Save Reference to Icon Div
    var icon = document.getElementById('weather_icon');
    // Update Display Icon
    icon.style.backgroundImage = 'url( ' + _config.wthr_icon_string + wthr_obj.icon + ')';

    // Listen for Click
    container.onclick = function () {
        // Check if working locally, if not, call EB.Clickthrough Method
        if (!EB._isLocalMode) { EB.clickthrough('Weather_Click', _config.wthr_clickthrough); } else { window.open(_config.wthr_clickthrough, '_blank'); }
    };

}

function displayWeatherError(_str, _config, _options) {
	// Establish reference to div container
	var container = document.getElementById(_config.container);
	// Set Container Div Width
    container.style.width = _options.width + 'px';
    // Set Container Div Height
    container.style.height = _options.height + 'px';
	// Build HTML String
	var htm = "<div id='weather_error' class='weather_text'>" + _str + "</div>";
	// Append HTML to the Target Div
    container.innerHTML = htm;
    // Listen for Click
    container.onclick = function () {
        // Check if working locally, if not, call EB.Clickthrough Method
        if (!EB._isLocalMode) { EB.clickthrough('Weather_Click', _config.wthr_clickthrough); } else { window.open(_config.wthr_clickthrough, '_blank'); }
    };
}

// Function that Adds Caps to the first letter of each word
function do_cap(_str) {
    // Split String into Seperate words
    var arr = _str.split(' ');
    // Loop through array and capitalize each first letter
    for (var i = 0; i < arr.length; i++) {
        arr[i] = arr[i].charAt(0).toUpperCase() + arr[i].substr(1).toLowerCase();
    }
    // Join array into full String
    var str = arr.join(' ');
    // Return String
    return str;
}
