// ************************************************************
//   This class is part of the Sizmek HTML5 Weather Ad Feature 
//   ALL RIGHTS RESERVED TO © 2017 Sizmek, Inc.
// ************************************************************
// ************************************************************
   
// Handle Display Build
function displayWeather(_obj, _config, _options)  {
    // Establish Weather Location
    var wthr_place = _obj.response.place;
    // Establish Weather Observation Object	
    var wthr_obj = _obj.response.ob;
    // Display Weather Object
    //console.log(wthr_obj);
    // Establish reference to div container
    var container = document.getElementById(_config.container);
    // Set Container Div Width
    container.style.width = _options.width + 'px';
    // Set Container Div Height
    container.style.height = _options.height + 'px';
    
    // Establish Object Property/Value String
    var htm = '';
    // Loop through Object Properties
    for (var prop in wthr_obj) {
        // Verify Property Exists
        if(!wthr_obj.hasOwnProperty(prop)) continue; 
        // Add Properties to String
        htm += prop + ": ";
        // Add Values to String
        htm += wthr_obj[prop] + '\n';
    }

    // Establish HTML String
    var html = '';
    // Build HTML String
    html += "<div id='weather_location' class='weather_text'>" + do_cap(wthr_place.name) + "</div>";
    html += "<div id='wthr_temp' class='weather_text'>" + wthr_obj.tempF + "&deg;</div>";
    html += "<div id='wthr_object'><textarea class='wthr_object_text wthr_text'>" + htm + "</textarea></div>";

    // Append HTML to the Target Div
    container.innerHTML = html;
    // Listen for Click
    container.onclick = function () {
        // Check if working locally, if not, call EB.Clickthrough Method 
        if (!EB._isLocalMode) { EB.clickthrough('Weather_Click', _config.wthr_clickthrough); } else { window.open(_config.wthr_clickthrough, '_blank'); }
    };

}

function displayWeatherError(_str, _config, _options) {
	// Establish reference to div container
	var container = document.getElementById(_config.container);
	// Set Container Div Width
    container.style.width = _options.width + 'px';
    // Set Container Div Height
    container.style.height = _options.height + 'px';
	// Build HTML String
	var htm = "<div id='weather_error' class='weather_text'>" + _str + "</div>";
	// Append HTML to the Target Div
    container.innerHTML = htm;
    // Listen for Click
    container.onclick = function () {
        // Check if working locally, if not, call EB.Clickthrough Method 
        if (!EB._isLocalMode) { EB.clickthrough('Weather_Click', _config.wthr_clickthrough); } else { window.open(_config.wthr_clickthrough, '_blank'); }
    };
}

// Function that Adds Caps to the first letter of each word
function do_cap(_str) {
    // Split String into Seperate words
    var arr = _str.split(' ');
    // Loop through array and capitalize each first letter
    for (var i = 0; i < arr.length; i++) {
        arr[i] = arr[i].charAt(0).toUpperCase() + arr[i].substr(1).toLowerCase();
    }
    // Join array into full String
    var str = arr.join(' ');
    // Return String
    return str;
}